View Issue Details

IDProjectCategoryView StatusLast Update
0000344Cinelerra-GG[All Projects] Bugpublic2019-12-08 18:47
ReporterOlaf Assigned ToPhyllisSmith  
PrioritynormalSeverityminorReproducibilityalways
Status acknowledgedResolutionopen 
Product Version 
Target VersionFixed in Version 
Summary0000344: Compositor: Zoom ignores the selected setting
DescriptionIf the user defines a magnification (menu bar), e.g. 1.0, the full screen display ignores the settings made by the user and remains in this changed setting (auto) when switching back.

See also:
- https://www.cinelerra-gg.org/bugtracker/view.php?id=237#c2461 Re: Adjustable background color of the compositor. 2019-11-15
- https://www.cinelerra-gg.org/bugtracker/view.php?id=343 Moire visible in HD video, 2019-11-28
TagsNo tags attached.

Activities

MatN

MatN

2019-12-08 18:47

reporter   ~0002557

Ah, now I see what you mean.
IMHO it is not a bug, because it works as designed. It could definitely be better, though.
When I configure for 2 workspaces (Mint 19.2 XFCE), I can switch back and forth using Ctrl-F1 and Ctrl-F2.
Suppose I use cin-gg in workspace 1, go full screen in the compositor, then indeed Ctrl-F2 doesn't react.
I can either wait a long time (a minute or so, then it seems to go back), or use the mouse left button to go out of full screen mode. Then I am immediately in workspace 2, so somehow the Ctrl-F2 made it through.

I hope GG can see a nicer way of implementing this. I think this ought to be a seperate issue, because it is unrelated to the zoom issue.
Olaf

Olaf

2019-12-08 08:52

reporter   ~0002556

> MatN: "I presume he means desktop workspaces, which on my XFCE desktop I switch to using Ctrl-F1 through Ctrl-F4. If I am full screen, it doesn't seem to do anything."
> PhyllisSmith: "Full screen mode is an "unmanaged window" and as such does not obey window manager orders."

I'm just saying it's a bug in CGG. Imagine for a moment the phone is ringing and you have to go to your customer data on the other workspace, but the compositor is stuck in full screen mode for some reason. How do you want to get out of this number? The compositor is only allowed to occupy one workspace, but not all. For this I mention the media players MPV and VLC, whose behaviour in full screen mode supports my argument.

By the way, Cinelerra's windows all have the same WM_CLASS. This shows that Cinelerra is not willing to work with window managers at all.
PhyllisSmith

PhyllisSmith

2019-12-07 23:41

manager   ~0002553

From note 2518 -- "fullscreen-in-the-root-window bug is back. After switching to another workspace and back again, the so called Compositor writes the full view into the root window of all workspaces."

Full screen mode is an "unmanaged window" and as such does not obey window manager orders. A lot of the popup windows in Cinelerra are also unmanaged windows. I was able to display the example.webp file to view what Olaf is talking about but it is not possible to switch workspaces in Fedora from an unmanaged workspace. That is, as MatN stated (note 2519) when you are in Full Screen mode, he could not even change workspaces and neither could I (I actually logged in as an ordinary user rather than my usual root and can confirm).

I am outlining potential changes to Zoom in the compositor to see if they can be implemented. For example, do not ignore fixed magnification when switch to full screen mode UNLESS in Auto mode or Protect Video from changes mode. And as MatN stated - "Basically a larger compositor window".
Olaf

Olaf

2019-12-04 22:15

reporter   ~0002540

And no, it's not possible for the Window Manger to impose this task. Firstly, the full screen cannot be guaranteed, because Window Manger can reject parts of it and thus an enlargement with "crooked" dimensions takes place and secondly, this is the task of the program to present a representation optimized in this view.
Olaf

Olaf

2019-12-04 22:03

reporter   ~0002539

MatN: "he wants the full screen display use the same zoom as currently used in the compositor. Basically a larger compositor window."
Exactly. Only it is and remains the compositor, only that, as I wrote before, a part of the controls is no longer accessible.
Olaf

Olaf

2019-12-04 21:52

reporter   ~0002538

> 0000344:0002533
to 1) Exactly. (Btw, black is so yesterday ;-)
to 2) No, what makes you think so? Think briefly about it.

Because we have a video editor and not a video player (even if this option is available). Just take a look at how other image editing programs (Gimp, Darktable …) switch to full screen mode. If you take it exactly, even the control elements shouldn't be faded out or only requested on explicit.
MatN

MatN

2019-12-04 21:04

reporter   ~0002537

Correction, I mean Olaf, not Pierre. Excuses.
MatN

MatN

2019-12-04 21:03

reporter   ~0002536

If I understand Pierre correctly, when he switches from compositor to full-screen, he wants the full screen display use the same zoom as currently used in the compositor. Basically a larger compositor window. I think that most people want full screen to show the full picture. But maybe his need can be accommodated by adding "shift-f" to the compositor's shortcuts, which means show compositor full screen with current magnification?
For working with masks, it is very handy to have the compositor not set to auto; when you zoom in it is easier. But then still I'd prefer full screen to mean full picture. However, I'm an occasional user. What do other heavy users think?
IgorBeg

IgorBeg

2019-12-04 18:28

reporter   ~0002533

I agree with MatN #0002525
For me the word “Full Screen” means to fill the screen completely, and it may be up-scaled or down-scaled due to your monitor resolution, but with the correct aspect ratio (16:9, 4:3, 21:10,…).

Eventually I can understand another option as “View 1:1” where the screen shows only the contain of the Compositor in the middle of the screen.
So,...
1) if my format project is HD (1280x720) and my screen is FHD (1920x1080), I will see the picture in the middle of the screen with an empty background color (black?) all around.
2) if my format project is UHD (4k, 8k,...) and my screen is FHD (1920x1080), I will see the picture in the middle of the screen but zoomed.

Another way for “Full Screen” option, could be,…
to fill the screen with the picture if the format project is greater than screen resolution (as it is now); if the format project is smaller than the screen resolution the picture is displayed with size 1:1, in the middle of the screen.

(cinelerra-5.1-ub16.04-20191130.x86_64-static)
Olaf

Olaf

2019-12-04 09:10

reporter   ~0002528

It's not that difficult. Videos and screenshots show that the majority of users have set their compositor to "automatic" most of the time. When switching to full-screen mode in automatic mode, the monitor shows a full screen display. So for the majority, nothing changes.

On the other hand, there is no argument that explains why a fixed magnification is ignored when switching to full screen. If the user wants a detailed view of 300 percent, then his decision has to be respected, regardless of the size of the compositor, with or without window decoration.

And it is also not a solution to force the user to manually search for an already set magnification again with the mouse or plus and minus keys after switching to the full screen. The correct way is to search for another magnification from the set and retained one! The compositor doesn't know any better than the user, he can't and shouldn't ignore the requirements of the user, no matter how crazy and absurd they may look for third parties.

The compositor has to be reworked anyway, because the switching doesn't work clean.
Pierre

Pierre

2019-12-04 01:21

updater   ~0002527

It's curious how difficult this discussion is to follow... it seems that there is no consensus on the objective sought by the full screen mode.

For me, the full screen mode is used to evaluate the impact of the image delimited by the composer's frame (like the viewer) but once reported to the total size of my monitor (whatever its resolution) and without the CinGG interface. As if I were watching the final rendering of what I did, on the screen chosen for the presentation.

If manipulations have been made on the composer's visible content, then this visible content (within the composer's framework) should be the same as that reported in full screen mode.
PhyllisSmith

PhyllisSmith

2019-12-04 00:05

manager   ~0002526

@Olaf -- I am missing it too !! When going full screen in the previous versions, the image on the display was the exact same size as in the compositor. That is, if the compositor was about 1/4 the size of the entire monitor, let's say in 50% mode on a 1080x1920 display the image is about 2 inches tall by 4 inches wide. When the user went to Full Screen mode, the image was still 2 inches x 4 inches. That did not make any sense to me.
MatN

MatN

2019-12-03 20:07

reporter   ~0002525

I'm not sure I follow you here. In my view, the "full screen" should display the whole picture, scaled as appropriate, not the compositor's windows content. E.g. a HD picture on a 1920x1080 screen should map pixel-perfect even if the compositor is in a 300% zoom, on a UHD monitor should be scaled up, and an UHD picture on a 1280x1024 screen must be scaled down. In both cases I expect "full screen" to show the whole picture. If a bigger compositor view is desired, increase the compositor window (save a separate layout if needed).
Note that is if the compositor "zoom view" is on, it is very easy to zoom in and out the the mouse scroll wheel, in both normal and full-screen mode. I find it especially convenient that when scrolling with the wheel, the center of the zoom is where the mouse pointer is. I noted yesterday that Adobe PP has no facility to scroll using the mouse wheel in full screen mode.
Olaf

Olaf

2019-12-02 09:40

reporter   ~0002520

The task was simple: maintain the magnification set by the user in each view. Example: A FullHD* must also be displayed in full view with 100 percent if 100 percent is set. This serves to evaluate the video in the size chosen by the user without disturbing accessories such as window frames and colorful background images. There is a difference in perception when a FullHD is scaled up to 2k, 4k or 8k or something else depending on the monitor, it is also a generated image.

*If in your test environment the used monitor can display FullHD at maximum in the resolution, a smaller size like 50 percent must be used for testing. This is the only way to check whether the magnification is maintained in the full view or whether the automatic scaling is used.
MatN

MatN

2019-12-01 14:19

reporter   ~0002519

I can confirm that with release 2019-11 my not-full-screen-used bug has been fixed. Just before the upgrade from 2019-10, I confirmed that is was still present there.

@Phyllis, I followed the same steps as in your video, except that I used the 'f' key to switch to and from full screen mode. In full screen mode the compositor picture occupied the upper left corner of the screen like in Olaf´s note 2516. Have you done the test using the vanilla 2019-10 release? Anyway, it is fixed now for me.

I don't know how to reproduce Olaf´s fullscreen-in-the-root-window bug from note 2518. I presume he means desktop workspaces, which on my XFCE desktop I switch to using Ctrl-F1 through Ctrl-F4. If I am full screen, it doesn't seem to do anything. If I am not full screen, switching back and forth doesn't not cause any noticable problems.

By the way, I could not display the .webp file in note 2518, the link is https://www.cinelerra-gg.org/bugtracker/file_download.php?file_id=378&type=bug , but I get the "MyView" screen instead. The .png picture in note 2516 works fine, and my Forefox should support .webp pictures.
Olaf

Olaf

2019-12-01 10:36

reporter   ~0002518

When I wrote it would work so far, it referred to the git version of November 30th.

In addition, the old fullscreen-in-the-root-window bug is back. After switching to another workspace and back again, the so called Compositor writes the full view into the root window of all workspaces.

CGG_fullscreen-in-the-root-window-bug.webp (56,012 bytes)
Olaf

Olaf

2019-11-30 09:18

reporter   ~0002516

Okay, works so far. However, it would be nicer if the video area were displayed in the center of the fullscreen view. Except in the "Auto" setting, the video area is set to the upper left quarter.

CGG_Fs_HD-x1.png (2,097 bytes)
CGG_Fs_HD-x1.png (2,097 bytes)
PhyllisSmith

PhyllisSmith

2019-11-30 03:50

manager   ~0002514

Changed the code so that now it remembers the magnification setting in the compositor before going fullscreen so that when leave fullscreen, you are back to the previous size. We had avoided doing this previously simply because that the parameter value was not readily available.

@MatN:
I am not able to create the issue you see so I must be misunderstanding something. In this quick video, I have a 1920x1080 video, set the compositor to 100%, and since my laptop's screen is 1920x1080, I correctly see the center portion of the image in the compositor. When I go fullscreen I see the entire image. Demo is at: https://streamable.com/xv77q
MatN

MatN

2019-11-29 18:49

reporter   ~0002511

What is also strange, if I edit an HD video, set the compositor magnification to 100% (about half the actual screen width), the put the compositor full screen, I don't get the full HD picture. This is on a 1920x1200 screen, it would fit without scaling.
100% will exactly fill the width of the screen, so I think showing only part of what was visible in the smaller compositor is incorrect.
If magnification is set to auto, it works fine.

Issue History

Date Modified Username Field Change
2019-11-28 14:41 Olaf New Issue
2019-11-29 14:48 PhyllisSmith Assigned To => PhyllisSmith
2019-11-29 14:48 PhyllisSmith Status new => acknowledged
2019-11-29 18:49 MatN Note Added: 0002511
2019-11-30 03:50 PhyllisSmith Note Added: 0002514
2019-11-30 09:18 Olaf File Added: CGG_Fs_HD-x1.png
2019-11-30 09:18 Olaf Note Added: 0002516
2019-12-01 10:36 Olaf File Added: CGG_fullscreen-in-the-root-window-bug.webp
2019-12-01 10:36 Olaf Note Added: 0002518
2019-12-01 14:19 MatN Note Added: 0002519
2019-12-02 09:40 Olaf Note Added: 0002520
2019-12-03 20:07 MatN Note Added: 0002525
2019-12-04 00:05 PhyllisSmith Note Added: 0002526
2019-12-04 01:21 Pierre Note Added: 0002527
2019-12-04 09:10 Olaf Note Added: 0002528
2019-12-04 18:28 IgorBeg Note Added: 0002533
2019-12-04 21:03 MatN Note Added: 0002536
2019-12-04 21:04 MatN Note Added: 0002537
2019-12-04 21:52 Olaf Note Added: 0002538
2019-12-04 22:03 Olaf Note Added: 0002539
2019-12-04 22:15 Olaf Note Added: 0002540
2019-12-07 23:41 PhyllisSmith Note Added: 0002553
2019-12-08 08:52 Olaf Note Added: 0002556
2019-12-08 18:47 MatN Note Added: 0002557